
#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 Red
#property indicator_color2 Green
#property indicator_color3 Red
#property indicator_color4 Green
#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 2
#property indicator_width4 2

//
//
//
//
//

extern int   MaMetod         = 1;
extern int   MaPeriod        = 30;
extern bool  alertsOn        = true;
extern bool  alertsOnCurrent = false;
extern bool  alertsMessage   = true;
extern bool  alertsSound     = false;
extern bool  alertsEmail     = false;
extern bool  alertsNotify    = false;

//
//
//
//
//

double Buffer1[];
double Buffer2[];
double Buffer3[];
double Buffer4[];
double trend[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(5);
   SetIndexBuffer(0,Buffer1); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,Buffer2); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,Buffer3); SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,Buffer4); SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(4,trend);
return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int pos,limit;
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);   
          
   //
   //
   //
   //
   //
   
   for(pos=limit; pos >= 0; pos--)
   {
      
      double maClose = iMA(NULL,0,MaPeriod,0,MaMetod,PRICE_CLOSE,pos);
      double maLow   = iMA(NULL,0,MaPeriod,0,MaMetod,PRICE_LOW,  pos);
      double maOpen  = iMA(NULL,0,MaPeriod,0,MaMetod,PRICE_OPEN, pos);
      double maHigh  = iMA(NULL,0,MaPeriod,0,MaMetod,PRICE_HIGH, pos);
      double haClose = (maOpen+maHigh+maLow+maClose)*0.25;
      double haOpen  = (Buffer3[pos+1]+Buffer4[pos+1])*0.50;
      double haHigh  = MathMax(maHigh,MathMax(haOpen,haClose));
      double haLow   = MathMin(maOpen,MathMin(haOpen,haClose));
          
      if (haOpen<haClose) { Buffer1[pos]=haLow;  Buffer2[pos]=haHigh; } 
      else                { Buffer1[pos]=haHigh; Buffer2[pos]=haLow;  } 
                            Buffer3[pos]=haOpen;
                            Buffer4[pos]=haClose;   
          
      trend[pos] = trend[pos+1];
      if (Buffer3[pos] < Buffer4[pos]) trend[pos] =  1;
      if (Buffer3[pos] > Buffer4[pos]) trend[pos] = -1;  
   }  
   
   //
   //
   //
   //
   //
   
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      if (trend[whichBar] != trend[whichBar+1])
      if (trend[whichBar] == 1)
            doAlert("up");
      else  doAlert("down");       
   }   
return(0);
}

//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Heiken Ashi Ma trend changed to ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Heiken Ashi ma "),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}
